macroScript BindRanger
category:"NCsoft" 
toolTip:"Bind Ranger 1.01" 
buttonText:"Bind Ranger 1.01"
-----------------------------
----v1.01 of Bind Ranger-----
---Written by Kiel Figgins---
------www.3dfiggins.com------
-----------------------------
--Automated interface to key the extremes of controls, joints and other objects for testing the bind
--------------------
--Version History
--------------------
-----
--1.01 (11-01-2006) - Turned off auto key after you've keyed ranges
--1.00 (10-12-2006) - Original Script
--------------------
--Coming Soon
--------------------
--instead of keying individual attr just key them all?

(

try(destroydialog bindRanger)catch()
rollout bindRanger "Bind Ranger                                                          v1.01" 
(
	label lbl001 "1." pos:[5,4] width:14 height:14
	checkbox chkRotOn "" pos:[19,4] width:17 height:15 checked:true
	label lblRotate "Rotate" pos:[39,5] width:35 height:14
	checkbox chkRX "X" pos:[108,4] width:30 height:15 checked:true
	checkbox chkRY "Y" pos:[144,4] width:30 height:15 checked:true
	checkbox chkRZ "Z" pos:[179,4] width:30 height:15 checked:true
	button btnRotAll "All" pos:[78,4] width:23 height:14
	button btnRotP25 "+25" pos:[232,4] width:23 height:14
	button btnRotM25 "-25" pos:[256,4] width:23 height:14
	spinner spnRotCust "Other" pos:[221,24] width:67 height:16 range:[0,360,75] type:#float
	radioButtons rdoRotAmt "" pos:[62,23] width:148 height:16 labels:#("75", "50", "25", "5") columns:4
	label lblRotAmount "Amount:" pos:[18,22] width:42 height:14
	label lbl002 "2." pos:[5,43] width:14 height:14
	checkbox chkTransOn "" pos:[19,43] width:17 height:15 checked:true
	label lblTrans "Trans" pos:[39,44] width:35 height:14
	checkbox chkTX "X" pos:[108,45] width:30 height:15 checked:true
	checkbox chkTY "Y" pos:[144,45] width:30 height:15 checked:true
	checkbox chkTZ "Z" pos:[179,45] width:30 height:15 checked:true
	button btnTransAll "All" pos:[78,45] width:23 height:14
	button btnTransP25 "+25" pos:[232,45] width:23 height:14
	button btnTransM25 "-25" pos:[256,45] width:23 height:14
	spinner spnTransCust "Other" pos:[221,63] width:67 height:16 range:[0,1000,75] type:#float
	radioButtons rdoTransAmt "" pos:[62,62] width:148 height:16 labels:#("75", "50", "25", "5") columns:4
	label lblTransAmount "Amount:" pos:[18,61] width:42 height:14
	label lbl003 "3." pos:[5,80] width:14 height:14
	checkbox chkScaleOn "" pos:[19,80] width:17 height:15 checked:false
	label lblScale "Scale" pos:[39,81] width:35 height:14
	checkbox chkSX "X" pos:[108,82] width:30 height:15 checked:true enabled:false
	checkbox chkSY "Y" pos:[144,82] width:30 height:15 checked:true enabled:false
	checkbox chkSZ "Z" pos:[179,82] width:30 height:15 checked:true enabled:false
	button btnScaleAll "All" pos:[78,82] width:23 height:14 enabled:false
	button btnScaleP1 "+1" pos:[232,82] width:23 height:14 enabled:false
	button btnScaleM1 "-1" pos:[256,82] width:23 height:14 enabled:false
	spinner spnScaleCust "Other" pos:[221,100] width:67 height:16 range:[0,1000,2] type:#float enabled:false
	radioButtons rdoScaleAmt "" pos:[62,99] width:140 height:16 labels:#("2", "1.5", ".5", "5") columns:4 enabled:false
	label lblScaleAmount "Amount:" pos:[18,98] width:42 height:14
	label lbl004 "4." pos:[5,129] width:14 height:14
	spinner spnFrameCust "Other" pos:[221,129] width:67 height:16 range:[1,1000,10] type:#integer scale:1
	radioButtons rdoFrameAmt "" pos:[90,129] width:101 height:16 labels:#("10", "5", "1") columns:3
	label lblFrameOffset "Frame Offset:" pos:[18,129] width:69 height:14
	label lbl15 "----------------------------------------------------------------------------------------------" pos:[6,117] width:295 height:12
	button btnCreate "Key Bind Ranges" pos:[86,155] width:104 height:22
	button btnDefault "<" pos:[274,149] width:14 height:14 tooltip:"Resets Back to Default"
	button btnHelp "?" pos:[274,163] width:14 height:14

--------------------------------
--Quick Keys
--------------------------------
on btnRotP25 pressed do
(
spnVal = spnRotCust.value
spnRotCust.value = spnVal + 25
)--End of btnRotP25

on btnRotM25 pressed do
(
spnVal = spnRotCust.value
spnRotCust.value = spnVal - 25
)--End of btnRotM25

on btnTransP25 pressed do
(
spnVal = spnTransCust.value
spnTransCust.value = spnVal + 25
)--End of btnTransP25

on btnTransM25 pressed do
(
spnVal = spnTransCust.value
spnTransCust.value = spnVal - 25
)--End of btnTransM25

on btnScaleP1 pressed do
(
spnVal = spnScaleCust.value
spnScaleCust.value = spnVal + 1
)--End of btnScaleP1

on btnScaleM1 pressed do
(
spnVal = spnScaleCust.value
spnScaleCust.value = spnVal - 1
)--End of btnScaleM1

--------------------------------
--Enable/Disable Options
--------------------------------
on chkRotOn changed theState do
(
onOff = chkRotOn.checked

if onOff == true then
	(
	btnRotAll.enabled = true
	chkRX.enabled = true
	chkRY.enabled = true
	chkRZ.enabled = true
	rdoRotAmt.enabled = true
	spnRotCust.enabled = true
	btnRotP25.enabled = true
	btnRotM25.enabled = true
	)
	else
	(
	btnRotAll.enabled = false
	chkRX.enabled = false
	chkRY.enabled = false
	chkRZ.enabled = false
	rdoRotAmt.enabled = false
	spnRotCust.enabled = false
	btnRotM25.enabled = false
	btnRotP25.enabled = false
	)
)--End of chkRotOn

on chkTransOn changed theState do
(
onOff = chkTransOn.checked

if onOff == true then
	(
	btnTransAll.enabled = true
	chkTX.enabled = true
	chkTY.enabled = true
	chkTZ.enabled = true
	rdoTransAmt.enabled = true
	spnTransCust.enabled = true
	btnTransM25.enabled = true
	btnTransP25.enabled = true
	)
	else
	(
	btnTransAll.enabled = false
	chkTX.enabled = false
	chkTY.enabled = false
	chkTZ.enabled = false
	rdoTransAmt.enabled = false
	spnTransCust.enabled = false
	btnTransM25.enabled = false
	btnTransP25.enabled = false
	)
)--End of chkTransOn

on chkScaleOn changed theState do
(
onOff = chkScaleOn.checked

if onOff == true then
	(
	btnScaleAll.enabled = true
	chkSX.enabled = true
	chkSY.enabled = true
	chkSZ.enabled = true
	rdoScaleAmt.enabled = true
	spnScaleCust.enabled = true
	btnScaleM1.enabled = true
	btnScaleP1.enabled = true
	)
	else
	(
	btnScaleAll.enabled = false
	chkSX.enabled = false
	chkSY.enabled = false
	chkSZ.enabled = false
	rdoScaleAmt.enabled = false
	spnScaleCust.enabled = false
	btnScaleM1.enabled = false
	btnScaleP1.enabled = false
	)
)--End of chkScaleOn

--------------------------------
--All Buttons
--------------------------------
on btnRotAll pressed do
(
	chkRX.state = true
	chkRY.state = true
	chkRZ.state = true
)--End of btnRotAll

on btnTransAll pressed do
(
	chkTX.state = true
	chkTY.state = true
	chkTZ.state = true
)--End of btnTransAll

on btnScaleAll pressed do
(
	chkSX.state = true
	chkSY.state = true
	chkSZ.state = true
)--End of btnScaleAll

--------------------------------
--Change Amounts Based on Radios
--------------------------------
on rdoRotAmt changed theState do
(
	if rdoRotAmt.state == 1 then
		(spnRotCust.value = 75) else()
	if rdoRotAmt.state == 2 then
		(spnRotCust.value = 50) else()
	if rdoRotAmt.state == 3 then
		(spnRotCust.value = 25) else()
	if rdoRotAmt.state == 4 then
		(spnRotCust.value = 5) else()
)--End of rdoRotAmt

on rdoTransAmt changed theState do
(
	if rdoTransAmt.state == 1 then
		(spnTransCust.value = 75) else()
	if rdoTransAmt.state == 2 then
		(spnTransCust.value = 50) else()
	if rdoTransAmt.state == 3 then
		(spnTransCust.value = 25) else()
	if rdoTransAmt.state == 4 then
		(spnTransCust.value = 5) else()
)--End of rdoTransAmt

on rdoScaleAmt changed theState do
(
	if rdoScaleAmt.state == 1 then
		(spnScaleCust.value = 2) else()
	if rdoScaleAmt.state == 2 then
		(spnScaleCust.value = 1.5) else()
	if rdoScaleAmt.state == 3 then
		(spnScaleCust.value = .5) else()
	if rdoScaleAmt.state == 4 then
		(spnScaleCust.value = 5) else()
)--End of rdoScaleAmt

on rdoFrameAmt changed theState do
(
	if rdoFrameAmt.state == 1 then
		(spnFrameCust.value = 10) else()
	if rdoFrameAmt.state == 2 then
		(spnFrameCust.value = 5) else()
	if rdoFrameAmt.state == 3 then
		(spnFrameCust.value = 1) else()
)--End of rdoFrameAmt

--------------------------------
--btnCreate
--------------------------------
on btnCreate pressed do
(
selCount = selection.count

if selCount == 0 then
(
print "Please select an Object"
)
else
(
	rotAmount = spnRotCust.value
	transAmount = spnTransCust.value
	scaleAmount = spnScaleCust.value
	frameCount = spnFrameCust.value
	
	initTime = sliderTime
	
	onOffRot = chkRotOn.checked
	onOffTrans = chkTransOn.checked
	onOffScale = chkScaleOn.checked
	
	onOffRX = chkRX.checked
	onOffRY = chkRY.checked
	onOffRZ = chkRZ.checked
	
	onOffTX = chkTX.checked
	onOffTY = chkTY.checked
	onOffTZ = chkTZ.checked
	
	onOffSX = chkSX.checked
	onOffSY = chkSY.checked
	onOffSZ = chkSZ.checked
	
	--Frame Offset Time line Adjust
	numOffset = 0
	frameRange = frameCount * 4
	
	if onOffRot == true then
		(
		if onOffRX == true then
			(numOffset = numOffset + 1) else()
		if onOffRY == true then
			(numOffset = numOffset + 1) else()
		if onOffRZ == true then
			(numOffset = numOffset + 1) else()
		)--End of onOffRot
		
	if onOffTrans == true then
		(
		if onOffTX == true then
			(numOffset = numOffset + 1) else()
		if onOffTY == true then
			(numOffset = numOffset + 1) else()
		if onOffTZ == true then
			(numOffset = numOffset + 1) else()
		)--End of onOffRot
	
	if onOffScale == true then
		(
		if onOffSX == true then
			(numOffset = numOffset + 1) else()
		if onOffSY == true then
			(numOffset = numOffset + 1) else()
		if onOffSZ == true then
			(numOffset = numOffset + 1) else()
		)--End of onOffRot
	
	newRange = (numOffset * frameRange) + initTime
	timeStart = (animationRange.start as integer)/TicksPerFrame
	animationRange = interval timeStart newRange
	
	set animate on
	
	if onOffRot == true then
		(
		if onOffRX == true then
			(
			max set key all x rotation
			curTime = sliderTime
			sliderTime = curTime + frameCount
			rotate $ (angleaxis rotAmount [1,0,0])
			curTime = sliderTime
			sliderTime = curTime + (frameCount *2)
			rotate $ (angleaxis -(rotAmount*2) [1,0,0])
			curTime = sliderTime
			sliderTime = curTime + frameCount
			rotate $ (angleaxis rotAmount [1,0,0])
			) else ()
		if onOffRY == true then
			(
			max set key all y rotation
			curTime = sliderTime
			sliderTime = curTime + frameCount
			rotate $ (angleaxis rotAmount [0,1,0])
			curTime = sliderTime
			sliderTime = curTime + (frameCount *2)
			rotate $ (angleaxis -(rotAmount*2) [0,1,0])
			curTime = sliderTime
			sliderTime = curTime + frameCount
			rotate $ (angleaxis rotAmount [0,1,0])
			) else ()
		if onOffRZ == true then
			(
			max set key all z rotation
			curTime = sliderTime
			sliderTime = curTime + frameCount
			rotate $ (angleaxis rotAmount [0,0,1])
			curTime = sliderTime
			sliderTime = curTime + (frameCount *2)
			rotate $ (angleaxis -(rotAmount*2) [0,0,1])
			curTime = sliderTime
			sliderTime = curTime + frameCount
			rotate $ (angleaxis rotAmount [0,0,1])
			) else ()
	) else ()--End of onOffRot
	
	if onOffTrans == true then
		(
		if onOffTX == true then
			(
			max set key all x position
			curTime = sliderTime
			sliderTime = curTime + frameCount
			move $ [transAmount,0,0]
			curTime = sliderTime
			sliderTime = curTime + (frameCount *2)
			move $ [-(transAmount*2),0,0]
			curTime = sliderTime
			sliderTime = curTime + frameCount
			move $ [transAmount,0,0]
			) else ()
		if onOffTY == true then
			(
			max set key all y position
			curTime = sliderTime
			sliderTime = curTime + frameCount
			move $ [0,transAmount,0]
			curTime = sliderTime
			sliderTime = curTime + (frameCount *2)
			move $ [0,-(transAmount*2),0]
			curTime = sliderTime
			sliderTime = curTime + frameCount
			move $ [0,transAmount,0]
			) else ()
		if onOffTZ == true then
			(
			max set key all z position
			curTime = sliderTime
			sliderTime = curTime + frameCount
			move $ [0,0,transAmount]
			curTime = sliderTime
			sliderTime = curTime + (frameCount *2)
			move $ [0,0,-(transAmount*2)]
			curTime = sliderTime
			sliderTime = curTime + frameCount
			move $ [0,0,transAmount]
			) else ()
	) else ()--End of onOffTrans
	
	scaleTime = sliderTime
	
	if onOffScale == true then
		(
		if onOffSX == true then
			(
			selArray = selection as array
			rightSel = selArray.count
				for i = 1 to rightSel do
				(
					local curObj = selArray[i]
					
					objSX = curObj.scale.x
					objSY = curObj.scale.y
					objSZ = curObj.scale.z
			
					max set key all scale
					curTime = sliderTime
					sliderTime = curTime + frameCount
					scale curObj [scaleAmount,1,1]
					curTime = sliderTime
					sliderTime = curTime + (frameCount *2)
					--curObj.scale = [objSX, objSY, objSZ]
					scale curObj [scaleAmount - scaleAmount,1,1]
					curTime = sliderTime
					sliderTime = curTime + frameCount
					curObj.scale = [objSX, objSY, objSZ]
					sliderTime = scaleTime
				)--End of For Loop
				sliderTime = scaleTime + frameRange
			) else ()
			
		scaleTime = sliderTime
		
		if onOffSY == true then
			(
			selArray = selection as array
			rightSel = selArray.count
				for i = 1 to rightSel do
				(
					local curObj = selArray[i]
					
					objSX = curObj.scale.x
					objSY = curObj.scale.y
					objSZ = curObj.scale.z
					
					max set key all scale
					curTime = sliderTime
					sliderTime = curTime + frameCount
					scale curObj [1,scaleAmount,1]
					curTime = sliderTime
					sliderTime = curTime + (frameCount *2)
					scale curObj [1,scaleAmount - scaleAmount,1]
					curTime = sliderTime
					sliderTime = curTime + frameCount
					curObj.scale = [objSX, objSY, objSZ]
					sliderTime = scaleTime
				)--End of For Loop
				sliderTime = scaleTime + frameRange
			) else ()
		
		scaleTime = sliderTime
		
		if onOffSZ == true then
			(
			selArray = selection as array
			rightSel = selArray.count
				for i = 1 to rightSel do
				(
					local curObj = selArray[i]
					
					objSX = curObj.scale.x
					objSY = curObj.scale.y
					objSZ = curObj.scale.z
					
					max set key all scale
					curTime = sliderTime
					sliderTime = curTime + frameCount
					scale curObj [1,1,scaleAmount]
					curTime = sliderTime
					sliderTime = curTime + (frameCount *2)
					scale curObj [1,1,scaleAmount - scaleAmount]
					curTime = sliderTime
					sliderTime = curTime + frameCount
					curObj.scale = [objSX, objSY, objSZ]
					sliderTime = scaleTime
				)--End of For Loop
				sliderTime = scaleTime + frameRange
			) else ()
	) else ()--End of onOffScale
	
	set animate off
	sliderTime = initTime
)--End of else for Verifying selection

)--End of btnCreate


on btnDefault pressed do
(
	chkRotOn.state = true
	chkTransOn.state = true
	chkScaleOn.state = false
	btnRotAll.enabled = true
	chkRX.enabled = true
	chkRY.enabled = true
	chkRZ.enabled = true
	rdoRotAmt.enabled = true
	spnRotCust.enabled = true
	btnTransAll.enabled = true
	chkTX.enabled = true
	chkTY.enabled = true
	chkTZ.enabled = true
	rdoTransAmt.enabled = true
	spnTransCust.enabled = true
	btnScaleAll.enabled = false
	chkSX.enabled = false
	chkSY.enabled = false
	chkSZ.enabled = false
	rdoScaleAmt.enabled = false
	spnScaleCust.enabled = false
	chkRX.state = true
	chkRY.state = true
	chkRZ.state = true
	chkTX.state = true
	chkTY.state = true
	chkTZ.state = true
	chkSX.state = true
	chkSY.state = true
	chkSZ.state = true
	rdoRotAmt.state = 1
	rdoTransAmt.state = 1
	rdoScaleAmt.state = 1
	rdoFrameAmt.state = 1
	spnFrameCust.value = 10
	spnRotCust.value = 75
	spnTransCust.value = 75
	spnScaleCust.value = 2
	btnTransP25.enabled = true
	btnTransM25.enabled = true
	btnRotP25.enabled = true
	btnRotM25.enabled = true
	btnScaleM1.enabled = false
	btnScaleP1.enabled = false
)--End btnDefault

on btnHelp pressed do
(
	rollout helpWin "About Bind Ranger"
	(
		label lbl001 "This script was created to key the extremes of controls, joints and other objects" align:#Left
		label lbl002 "to quickly and accurately test the ranges for the bind's integrity." align:#Left
		label lbl003 ""
		label lbl004 "To Use:" align:#Left
		label lbl005 "-Select and Object" align:#Left
		label lbl006 "-Adjust the settings in the window" align:#Left
		label lbl007 "-Click 'Key Bind Ranges'" align:#Left
		label lbl008 ""
		label lbl009 "From there it should have moved your object appropriately to your settings" align:#Left
		label lbl010 ""
		label lbl011 "Note: A strange keying occassional happens that warps the key set" align:#Left
		label lbl012 "I have not been able to duplicate it reliablity, so if it happens" align:#Left
		label lbl013 "Delete the newly made keys, and try again, it normally clears up." align:#Left
		label lbl014 ""
		label lbl015 "If you find what the error is, please let me know." align:#Left
	)--End of helpWin Rollout
	createDialog helpWin width:395
)--End of btnHelp
	

)--End of bindRanger Rollout
createDialog bindRanger width:292 height:181 pos:[1010,80] \
style:#(#style_border, #style_titlebar, #style_sysmenu, #style_minimizebox)
try(cui.RegisterDialogBar bindRanger maxsize:[292,181]) catch()

)--End of Script
